%% OP-AMP Test

%% test 1 (integrator)

filename = 'oaf1.net';
type(filename);
parse;
symbuild;
idn = find(strcmp(yname,'V(out)'));

s = sym('s');
H = inv(Gm+Cm*s)*Is;
fprintf('\noutput is %s\n',char(yname(idn)));
pretty(H(idn))

%% test 2 (Sallen-Key lowpass filter)

filename = 'oaf2.net';
type(filename);
parse;
symbuild;
idn = find(strcmp(yname,'V(out)'));


s = sym('s');
H = inv(Gm+Cm*s)*Is;
fprintf('\noutput is %s\n',char(yname(idn)));
pretty(H(idn))

%%

syms C1 C2 R1 R2 R3 R4
a1 = C1*C2*R1*R2*R3;
a2 = (C2*R1*R3+C2*R2*R3-C1*R1*R4);
a3 = R3;
b1 = R3+R4;
w0 = sqrt(a3/a1);
alpha = a2/a1
gain = b1/a3

%%
sysbuild;

H = inv(Gm+Cm*s)*Is;
fprintf('\noutput is %s\n',char(yname(idn)));
pretty(H(idn))

%%
b1 = 7136238463529799405291429847247475681913733120;
a1 = 5666839779443574375;
a2 = 37778931862957161709568;

gain = b1/a2^2

tau = a1/a2
1/tau

%%

r = a1/a2;
a = [r^2 2*r 1];
b = 1;
f = logspace(1,5,401);
freqs(b,a,f);

%% test 3 (Sallen-Key highpass filter)

filename = 'oaf3.net';
type(filename);
parse;
symbuild;
idn = find(strcmp(yname,'V(out)'));


s = sym('s');
H = inv(Gm+Cm*s)*Is;
fprintf('\noutput is %s\n',char(yname(idn)));
pretty(H(idn))

%%
sysbuild;

H = inv(Gm+Cm*s)*Is;
fprintf('\noutput is %s\n',char(yname(idn)));
pretty(H(idn))

%%
b1 = 100353353393387808336209013987989501953125;

% a1 s^2 + a2 s + a3
a1 = 20070670678677560827382146445383516569375;
a2 = 267608942382367488896557370634638554728235008;
a3 = 892029807941224925661428730905934460239216640000;

% high-frequency gain (s->infinity)
gain = b1/a1

% ax^2 + bx + c radical = b^2 - 4*a*c
a1/a3
a2/a3
radical = a2^2 - 4*a1*a3
roots([a1 a2 a3])


%%

a = [1 a2/a1 a3/a1];
b = [b1/a1 0 0]/gain;
f = logspace(1,5,401);
freqs(b,a,f);
