%% RC Filters

%% rcf1.net

filename='rcf1.net';
type(filename);
parse;
sysbuild
s = sym('s');
tau = 1600*1e-6;
fc = 1/(2*pi*tau);
fprintf('cut-off frequency %g Hz\n',fc);
yname
idn = find(strcmp(yname,'V(out)'));

%%

% Transfer function
H =inv(Gm+Cm*s)*Is;
H(idn)

%%

% coefficients
a1 = [1 625];
b1 = 625;


%% rcf2.net

filename='rcf2.net';
type(filename);
parse;
sysbuild
s = sym('s');
yname
idn = find(strcmp(yname,'V(out)'));

%% 

% Transfer function
H = inv(Gm+Cm*s)*Is;
H(idn)

%%

% coefficients
a2 = [ 1 1875 625^2];
b2 = 625^2;

% note that 
a2x = conv(a1,a1)

%%

f = logspace(1,3,201);
s = 1j*2*pi*f;
h1 = polyval(b2,s)./polyval(a2x,s);
h2 = polyval(b2,s)./polyval(a2,s);
db1 = 20*log10(abs(h1));
db2 = 20*log10(abs(h2));
ph = semilogx(f,db1,f,db2,'LineWidth',2);
legend(ph,'transfer function cascade','circuit cascade');
axis([10 1000 -10 0]);
hold on
dbx = 20*log10(1/2);
plot([10 1000],[dbx dbx],'b--');
fc = interp1(db1,f,dbx);
plot([fc fc],[-10 0],'b--');
hold off;
grid
xlabel('frequency (Hz)');
ylabel('response (dB)');
fprintf('frequency at %g db = %g Hz\n',dbx,fc);

%% rcf3.net 

% two RC circuits buffered by opamp voltage follower
filename='rcf3.net';
type(filename);
parse;
sysbuild
s = sym('s');
yname
idn = find(strcmp(yname,'V(out)'));

%% 

% Transfer function
H = inv(Gm+Cm*s)*Is;
H(idn)
